unit ChurchCensus;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Grids, ExtCtrls, StdCtrls;

type
  TChurchForm = class(TForm)
    DrawGrid1: TDrawGrid;
    CensusPanel: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    NumLblNR: TLabel;
    NumLbl1: TLabel;
    NumLbl2: TLabel;
    NumLbl3: TLabel;
    NumLbl4: TLabel;
    NumLbl5: TLabel;
    NumLbl6: TLabel;
    NumLbl7: TLabel;
    NumLbl8: TLabel;
    NumLbl9: TLabel;
    NumLbl10: TLabel;
    NumLbl11: TLabel;
    procedure DisplayStart;
    procedure DrawGrid1DrawCell(Sender: TObject; Col, Row: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure PaintScreen;
    procedure ClearArray;
    procedure DisplaySize;
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  ChurchForm: TChurchForm;

implementation

uses Main;

{$R *.DFM}

type
  TCensColArray = array[0..22] of char;
  TCensusArray = array[0..1] of TCensColArray;

var
  CensusArray : TCensusArray;

procedure TChurchForm.ClearArray;
var
  I, J : integer;
begin
  for J := 0 to 1 do
  begin
    for I := 0 to 22 do
    begin
      CensusArray[I,J] := 'z';
    end;
  end;
  ChurchForm.PaintScreen;
end;

procedure TChurchForm.DisplaySize;
begin
  if ChurchSize[0] > 0 then NumLblNR.Caption := IntToStr(ChurchSize[0])
                       else NumLblNR.Caption := '';
  if ChurchSize[1] > 0 then NumLbl1.Caption := IntToStr(ChurchSize[1])
                       else NumLbl1.Caption := '';
  if ChurchSize[2] > 0 then NumLbl2.Caption := IntToStr(ChurchSize[2])
                       else NumLBl2.Caption := '';
  if ChurchSize[3] > 0 then NumLbl3.Caption := IntToStr(ChurchSize[3])
                       else NumLBl3.Caption := '';
  if ChurchSize[4] > 0 then NumLbl4.Caption := IntToStr(ChurchSize[4])
                       else NumLBl4.Caption := '';
  if ChurchSize[5] > 0 then NumLbl5.Caption := IntToStr(ChurchSize[5])
                       else NumLBl5.Caption := '';
  if ChurchSize[6] > 0 then NumLbl6.Caption := IntToStr(ChurchSize[6])
                       else NumLBl6.Caption := '';
  if ChurchSize[7] > 0 then NumLbl7.Caption := IntToStr(ChurchSize[7])
                       else NumLBl7.Caption := '';
  if ChurchSize[8] > 0 then NumLbl8.Caption := IntToStr(ChurchSize[8])
                       else NumLBl8.Caption := '';
  if ChurchSize[9] > 0 then NumLbl9.Caption := IntToStr(ChurchSize[9])
                       else NumLBl9.Caption := '';
  if ChurchSize[10] > 0 then NumLbl10.Caption := IntToStr(ChurchSize[10])
                        else NumLbl10.Caption := '';
  if ChurchSize[11] > 0 then NumLbl11.Caption := IntToStr(ChurchSize[11])
                        else NumLBl11.Caption := '';
  {dummy}
end;

procedure TChurchForm.DisplayStart;
var
   I, J : integer;
begin

  if ScreenHeight < 700 then
  begin
    Height := 540;
    ClientHeight := 505;
    Width := 138;
    ClientWidth := 130;

    DrawGrid1.DefaultColWidth := 65;
    DrawGrid1.DefaultRowHeight := 21;
    CensusPanel.Width := 65;
    NumLbl1.Font.Size := 12;
    NumLbl2.Font.Size := 12;
    NumLbl3.Font.Size := 12;
    NumLbl4.Font.Size := 12;
    NumLbl5.Font.Size := 12;
    NumLbl6.Font.Size := 12;
    NumLbl7.Font.Size := 12;
    NumLbl8.Font.Size := 12;
    NumLbl9.Font.Size := 12;
    NumLbl10.Font.Size := 12;
    NumLbl11.Font.Size := 12;
    NumLblNR.Font.Size := 12;

    NumLblNR.Top := 3;
    NumLbl1.Top := 47;
    NumLbl2.Top := 91;
    NumLbl3.Top := 135;
    NumLbl4.Top := 179;
    NumLbl5.Top := 223;
    NumLbl6.Top := 267;
    NumLbl7.Top := 311;
    NumLbl8.Top := 355;
    NumLbl9.Top := 399;
    NumLbl10.Top := 443;
    NumLbl11.Top := 487;

    Label1.Font.Size := 8;
    Label2.Font.Size := 8;
    Label3.Font.Size := 8;
    Label4.Font.Size := 8;
    Label5.Font.Size := 8;
    Label6.Font.Size := 8;
    Label7.Font.Size := 8;
    Label8.Font.Size := 8;
    Label9.Font.Size := 8;
    Label10.Font.Size := 8;
    Label11.Font.Size := 8;
    Label12.Font.Size := 8;

    Label1.Top := 4;
    Label2.Top := 48;
    Label3.Top := 92;
    Label4.Top := 136;
    Label5.Top := 180;
    Label6.Top := 224;
    Label7.Top := 268;
    Label8.Top := 312;
    Label9.Top := 356;
    Label10.Top := 400;
    Label11.Top := 444;
    Label12.Top := 488;


    NumLbl1.Left := 55;
    NumLbl2.Left := 55;
    NumLbl3.Left := 55;
    NumLbl4.Left := 55;
    NumLbl5.Left := 55;
    NumLbl6.Left := 55;
    NumLbl7.Left := 55;
    NumLbl8.Left := 55;
    NumLbl9.Left := 55;
    NumLbl10.Left := 55;
    NumLbl11.Left := 55;
    NumLblNR.Left := 55;


  end;

     {adjusts form to center on display, on left side}
  ChurchForm.Top := Trunc(ScreenHeight/2) - Trunc(Height/2);
  ChurchForm.Left := 2;

  CensusPanel.Color := clLtYell;
  DrawGrid1.Color := clLtYell;


     {sets up & fills array}
  ChurchForm.ClearArray;
  J := 0;
  I := 0;
  CensusArray[I,J] := 'w';
  repeat
    I := I + 2;
    CensusArray[I,J] := ColorCode[Trunc(I/2)];
  until I = 2*ChurchCounter;
  DisplaySize;
  ChurchForm.PaintScreen;
  ChurchForm.FormStyle := fsStayOnTop;
  ChurchForm.Visible := true;
end;

procedure TChurchForm.DrawGrid1DrawCell(Sender: TObject; Col, Row : Integer;
  Rect: TRect; State: TGridDrawState);

begin
  with DrawGrid1.Canvas do
  begin
    if CensusArray[Row,Col] = 'r' then Brush.Color := clRed;
    if CensusArray[Row,Col] = 'b' then Brush.Color := clBlue;
    if CensusArray[Row,Col] = 'g' then Brush.Color := clGreen;
    if CensusArray[Row,Col] = 'y' then Brush.Color := clYellow;
    if CensusArray[Row,Col] = 'a' then Brush.Color := clAqua;
    if CensusArray[Row,Col] = 'l' then Brush.Color := clLime;
    if CensusArray[Row,Col] = 'm' then Brush.Color := clMaroon;
    if CensusArray[Row,Col] = 't' then Brush.Color := clTeal;
    if CensusArray[Row,Col] = 'f' then Brush.Color := clFuchsia;
    if CensusArray[Row,Col] = 's' then Brush.Color := clSilver;
    if CensusArray[Row,Col] = 'o' then Brush.Color := clOlive;
    if CensusArray[Row,Col] = 'p' then Brush.Color := clPurple;
    if CensusArray[Row,Col] = 'n' then Brush.Color := clNavy;
    if CensusArray[Row,Col] = 'w' then Brush.Color := clWhite;
    if CensusArray[Row,Col] = 'z' then Brush.Color := clLtYell;
    TextOut(Rect.Left,Rect.Top,'                                                                                                    ');
    TextOut(Rect.Left,Rect.Top+12,'                                                                                                    ');
    TextOut(Rect.Left,Rect.Top+24,'                                                                                                    ');
  end;
 
end;

procedure TChurchForm.PaintScreen;
var
  I, J : integer;
  Carrier : TRect;
  StateSet : TGridDrawState;
begin
  for I := 0 to 22 do
  begin
    for J := 0 to 1 do
    begin
      with ChurchForm do
      begin
        Carrier := DrawGrid1.CellRect(J,I);
        DrawGrid1DrawCell(ChurchForm,I,J,Carrier,StateSet);
      end;
    end;
  end;
end;
























end.
